.\" 
.\" Copyright (c) 1994 Joerg Wunsch
.\" 
.\" All rights reserved.
.\" 
.\" This program is free software.
.\" 
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\" 	This product includes software developed by Joerg Wunsch
.\" 4. The name of the developer may not be used to endorse or promote
.\"    products derived from this software without specific prior written
.\"    permission.
.\" 
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\" 
.\" $Header: /home/ncvs/src/usr.sbin/pcvt/vgaio/vgaio.8,v 1.1.1.1 1995/02/05 13:49:23 jkh Exp $
.\" -hm updated 31.12.94
.\" 
.Dd December 31, 1994
.Dt VGAIO 8
.Sh NAME
.Nm vgaio
.Nd perform input/output on a Video Graphics Array
.Sh SYNOPSIS
.Nm vgaio
.Op Fl d
.Sh DESCRIPTION
.Ss Purpose
.Nm Vgaio
is used to perform register-level input/output on a Video Graphics Array.
Since some of the sequences required to access those registers are very
silly,
.Nm vgaio
cares of all the things necessary and allows the user to access the
registers of several register groups with their symbolic names.

.Ss Options
.Bl -tag -width 10n -offset indent
.It Fl d
Turn on the grammar parser debugger.

.El
.Ss Command language
The command language of
.Nm
constitutes of some very simple tokens and rules. Commands are executed
line by line as they are entered. Each line may contain any number of
semicolon-separated input/output commands.

Symbolic register names look like:

.D1 Ao Em reggroup Ac Ao Em regnumber Ac

with
.Aq Em regnumber
being any hexadecimal number
.Pq without a leading Em 0x ,
and
.Aq Em reggroup
one of the strings
.Dq Em ar ,
.Dq Em cr ,
.Dq Em gr ,
.Dq Em mi ,
or
.Dq Em sr ,
standing for the
.Em Attribute controller ,
.Em CRT controller ,
.Em Graphics controller ,
.Em Miscellaneous Output Register ,
or
.Em Timing sequencer ,
respectively.

An input instruction has the form

.D1 Ao Em regname Ac ?

and will cause
.Nm
to output a line like

.Bd -ragged -offset indent
.Ao Em regname Ac \& = 0x Ns
.Aq Em number
.Ed

An output instruction looks like

.Bd -ragged -offset indent
.Ao Em regname Ac =
.Aq Em number
.Ed

Spaces or Tabs between the
.Aq Em reggroup ,
the
.Aq Em regnumber ,
or any of the other tokens are ignored. They are not required anyway.

The 
.Dq Em mi
needs a single unused argument to satisfy the syntax :-) (-hm).


.Ss Access control
The caller must have uid 0 in order to gain the required access to
the IO registers.

.Sh HISTORY
This program is considered
.Dq hackware .
It has been developed in order to simplify the process of developing other
software that needs to program the Video Graphics Array.

Remember, to use this program, your kernel has to be compiled with XSERVER
being defined !

.Sh AUTHOR
The program has been contributed by
.if n Joerg Wunsch,
.if t J\(:org Wunsch,
Dresden
.Aq joerg_wunsch@uriah.sax.de .

